unit Childwin;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, ExtCtrls,
  StdCtrls, Buttons, SysUtils, Opcje, Dialogs;

type
  TMDIChild = class(TForm)
    Image: TImage;
    A1Edit: TEdit;
    A2Edit: TEdit;
    W1Edit: TEdit;
    W2Edit: TEdit;
    Fi1Edit: TEdit;
    Fi2Edit: TEdit;
    Pi1Edit: TEdit;
    Pi2Edit: TEdit;
    XY1RadioGroup: TRadioGroup;
    XY2RadioGroup: TRadioGroup;
    KolorButton1: TBitBtn;
    KolorButton2: TBitBtn;
    KolorButton3: TBitBtn;
    XCheckBox: TCheckBox;
    YCheckBox: TCheckBox;
    XYCheckBox: TCheckBox;
    OsieCheckBox: TCheckBox;
    JednostkiCheckBox: TCheckBox;
    OkresCheckBox: TCheckBox;
    XTabSetNumber: TLabel;
    YTabSetNumber: TLabel;
    NumerLabel: TLabel;
    pow_x: TLabel;
    pow_y: TLabel;
    x0: TLabel;
    y0: TLabel;
    Panel: TPanel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PanelEnter(Sender: TObject);
    procedure PanelExit(Sender: TObject);
  private
    { Private declarations }
    Ruszanie:boolean;
    OldX:Integer;
    OldY:Integer;
    OldX0:Integer;
    OldY0:Integer;
  public
    { Public declarations }
    procedure CopyFromMulti;
    procedure CopyToMulti;
    function NumerKomponentu(nazwa:string):integer;
  end;

implementation

{$R *.DFM}

uses Main;

function TMDIChild.NumerKomponentu(nazwa:string):integer;
var j,numer:integer;
begin
  numer:=-1;
  for j:=0 to componentcount-1 do
  begin
    if components[j].name=nazwa then numer:=j;
  end;
  {$IFDEF TEST}
  if numer=-1 then
  begin
    application.messagebox('Brak komponentu !','Warning',MB_OK);
    halt;
  end;
  {$ENDIF}
  NumerKomponentu:=numer;
end;

procedure TMDIChild.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TMDIChild.CopyFromMulti;
begin
  TCheckBox(components[numerkomponentu('OsieCheckBox')]).Checked:=MultiPageDlg.OsieCheckBox.Checked;
  TCheckBox(components[numerkomponentu('JednostkiCheckBox')]).Checked:=MultiPageDlg.JednostkiCheckBox.Checked;
  TCheckBox(components[numerkomponentu('OkresCheckBox')]).Checked:=MultiPageDlg.OkresCheckBox.Checked;
  TCheckBox(components[numerkomponentu('XCheckBox')]).Checked:=MultiPageDlg.XCheckBox.Checked;
  TCheckBox(components[numerkomponentu('YCheckBox')]).Checked:=MultiPageDlg.YCheckBox.Checked;
  TCheckBox(components[numerkomponentu('XYCheckBox')]).Checked:=MultiPageDlg.XYCheckBox.Checked;
  TBitBtn(components[numerkomponentu('KolorButton1')]).Font.Color:=MultiPageDlg.Kolor3Panel.Font.Color;
  TBitBtn(components[numerkomponentu('KolorButton2')]).Font.Color:=MultiPageDlg.Kolor4Panel.Font.Color;
  TBitBtn(components[numerkomponentu('KolorButton3')]).Font.Color:=MultiPageDlg.Kolor5Panel.Font.Color;
  TEdit(components[numerkomponentu('A1Edit')]).Text:=MultiPageDlg.A1Edit.Text;
  TEdit(components[numerkomponentu('A2Edit')]).Text:=MultiPageDlg.A2Edit.Text;
  TEdit(components[numerkomponentu('W1Edit')]).Text:=MultiPageDlg.W1Edit.Text;
  TEdit(components[numerkomponentu('W2Edit')]).Text:=MultiPageDlg.W2Edit.Text;
  TEdit(components[numerkomponentu('Fi1Edit')]).Text:=MultiPageDlg.Fi1Edit.Text;
  TEdit(components[numerkomponentu('Fi2Edit')]).Text:=MultiPageDlg.Fi2Edit.Text;
  TEdit(components[numerkomponentu('Pi1Edit')]).Text:=MultiPageDlg.Pi1Edit.Text;
  TEdit(components[numerkomponentu('Pi2Edit')]).Text:=MultiPageDlg.Pi2Edit.Text;
  TRadioGroup(components[numerkomponentu('XY1RadioGroup')]).ItemIndex:=MultiPageDlg.XY1RadioGroup.ItemIndex;
  TRadioGroup(components[numerkomponentu('XY2RadioGroup')]).ItemIndex:=MultiPageDlg.XY2RadioGroup.ItemIndex;
  TLabel(components[numerkomponentu('XTabSetNumber')]).Caption:=inttostr(MultiPageDlg.NotebookX.PageIndex);
  TLabel(components[numerkomponentu('YTabSetNumber')]).Caption:=inttostr(MultiPageDlg.NotebookY.PageIndex);
end;

procedure TMDIChild.CopyToMulti;
begin
  MultiPageDlg.OsieCheckBox.Checked:=TCheckBox(components[numerkomponentu('OsieCheckBox')]).Checked;
  MultiPageDlg.JednostkiCheckBox.Checked:=TCheckBox(components[numerkomponentu('JednostkiCheckBox')]).Checked;
  MultiPageDlg.OkresCheckBox.Checked:=TCheckBox(components[numerkomponentu('OkresCheckBox')]).Checked;
  MultiPageDlg.XCheckBox.Checked:=TCheckBox(components[numerkomponentu('XCheckBox')]).Checked;
  MultiPageDlg.YCheckBox.Checked:=TCheckBox(components[numerkomponentu('YCheckBox')]).Checked;
  MultiPageDlg.XYCheckBox.Checked:=TCheckBox(components[numerkomponentu('XYCheckBox')]).Checked;
  MultiPageDlg.Kolor3Panel.Font.Color:=TBitBtn(components[numerkomponentu('KolorButton1')]).Font.Color;
  MultiPageDlg.Kolor4Panel.Font.Color:=TBitBtn(components[numerkomponentu('KolorButton2')]).Font.Color;
  MultiPageDlg.Kolor5Panel.Font.Color:=TBitBtn(components[numerkomponentu('KolorButton3')]).Font.Color;
  MultiPageDlg.A1Edit.Text:=TEdit(components[numerkomponentu('A1Edit')]).Text;
  MultiPageDlg.A2Edit.Text:=TEdit(components[numerkomponentu('A2Edit')]).Text;
  MultiPageDlg.W1Edit.Text:=TEdit(components[numerkomponentu('W1Edit')]).Text;
  MultiPageDlg.W2Edit.Text:=TEdit(components[numerkomponentu('W2Edit')]).Text;
  MultiPageDlg.Fi1Edit.Text:=TEdit(components[numerkomponentu('Fi1Edit')]).Text;
  MultiPageDlg.Fi2Edit.Text:=TEdit(components[numerkomponentu('Fi2Edit')]).Text;
  MultiPageDlg.Pi1Edit.Text:=TEdit(components[numerkomponentu('Pi1Edit')]).Text;
  MultiPageDlg.Pi2Edit.Text:=TEdit(components[numerkomponentu('Pi2Edit')]).Text;
  MultiPageDlg.XY1RadioGroup.ItemIndex:=TRadioGroup(components[numerkomponentu('XY1RadioGroup')]).ItemIndex;
  MultiPageDlg.XY2RadioGroup.ItemIndex:=TRadioGroup(components[numerkomponentu('XY2RadioGroup')]).ItemIndex;
  MultiPageDlg.NotebookX.PageIndex:=strtoint(TLabel(components[numerkomponentu('XTabSetNumber')]).Caption);
  MultiPageDlg.NotebookY.PageIndex:=strtoint(TLabel(components[numerkomponentu('YTabSetNumber')]).Caption);
end;

procedure TMDIChild.FormCreate(Sender: TObject);
begin
  Image.Width:=Screen.Width;
  Image.Height:=Screen.Height;
  TLabel(components[numerkomponentu('x0')]).Caption:=inttostr(screen.width div 2);
  TLabel(components[numerkomponentu('y0')]).Caption:=inttostr(screen.height div 2);
end;

procedure TMDIChild.ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var p:integer;
begin
  if Ruszanie then
  begin
    if OldX<>X then
    begin
      if HorzScrollBar.Range>Width then
      begin
        if OldX<X then
        begin
          p:=HorzScrollBar.Position+(X-OldX);
          HorzScrollBar.Position:=p;
        end;
        if OldX>X then
        begin
          p:=HorzScrollBar.Position-(OldX-X);
          HorzScrollBar.Position:=p;
        end;
      end;
    end;
    if OldY<>Y then
    begin
      if VertScrollBar.Range>Height then
      begin
        if OldY<Y then
        begin
          p:=VertScrollBar.Position+(Y-OldY);
          VertScrollBar.Position:=p;
        end;
        if OldY>Y then
        begin
          p:=VertScrollBar.Position-(OldY-Y);
          VertScrollBar.Position:=p;
        end;
      end;
    end;
    OldX:=X;
    OldY:=Y;
  end;
end;

procedure TMDIChild.ImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Ruszanie:=True;
  OldX:=X;
  OldX0:=X;
  OldY:=Y;
  OldY0:=Y;
end;

procedure TMDIChild.ImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  pow_x,pow_y:integer;
begin
  Ruszanie:=False;
  if (OldX0=X) and (OldY0=Y) then
  begin
    pow_x:=strtoint(tlabel(components[numerkomponentu('pow_x')]).caption);
    pow_y:=strtoint(tlabel(components[numerkomponentu('pow_y')]).caption);
    if Button=mbLeft then
    begin
      if pow_x<100 then
      begin
        pow_x:=pow_x*2;
        pow_y:=pow_y*2;
      end;
    end;
    if Button=mbRight then
    begin
      if pow_x>=20 then
      begin
        pow_x:=pow_x div 2;
        pow_y:=pow_y div 2;
      end;
    end;
    tlabel(components[numerkomponentu('pow_x')]).caption:=inttostr(pow_x);
    tlabel(components[numerkomponentu('pow_y')]).caption:=inttostr(pow_y);
    MainForm.RysujWykres;
  end;
end;

procedure TMDIChild.PanelEnter(Sender: TObject);
begin
  CopyToMulti;
end;

procedure TMDIChild.PanelExit(Sender: TObject);
begin
  CopyFromMulti;
end;

end.
