unit Main;

interface

uses WinTypes, WinProcs, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, Opcje, About, ClipBrd, Galeria;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    Edit1: TMenuItem;
    CopyItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    N2: TMenuItem;
    OptionsItem: TMenuItem;
    SaveDialog: TSaveDialog;
    FileCloseAllItem: TMenuItem;
    N3: TMenuItem;
    HelpItem: TMenuItem;
    HelpOnHelpItem: TMenuItem;
    GalleryItem: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FileNewItemClick(Sender: TObject);
    procedure WindowCascadeItemClick(Sender: TObject);
    procedure UpdateMenuItems(Sender: TObject);
    procedure WindowTileItemClick(Sender: TObject);
    procedure WindowArrangeItemClick(Sender: TObject);
    procedure FileCloseItemClick(Sender: TObject);
    procedure FileExitItemClick(Sender: TObject);
    procedure FileSaveAsItemClick(Sender: TObject);
    procedure CopyItemClick(Sender: TObject);
    procedure WindowMinimizeItemClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OptionsItemClick(Sender: TObject);
    procedure HelpAboutItemClick(Sender: TObject);
    procedure FileCloseAllItemClick(Sender: TObject);
    procedure HelpItemClick(Sender: TObject);
    procedure HelpOnHelpItemClick(Sender: TObject);
    procedure GalleryItemClick(Sender: TObject);
  private
    { Private declarations }
    procedure CreateMDIChild(const Name: string);
  public
    { Public declarations }
    procedure RysujWykres;
    function Osie:integer;
    function str2real(s:string):extended;
    function real2int(x:extended):integer;
  end;

function NumerKomponentu2(nazwa:string):integer;

var
  MainForm: TMainForm;

const
  krok=0.1;

implementation

{$R *.DFM}

uses ChildWin;

function NumerKomponentu2(nazwa:string):integer;
var j,numer:integer;
begin
  numer:=-1;
  for j:=0 to MainForm.ActiveMDIChild.componentcount-1 do
  begin
    if MainForm.ActiveMDIChild.components[j].name=nazwa then numer:=j;
  end;
  {$IFDEF TEST}
  if numer=-1 then
  begin
    application.messagebox('Brak komponentu !','Warning',MB_OK);
    halt;
  end;
  {$ENDIF}
  NumerKomponentu2:=numer;
end;

function TMainForm.Osie:integer;
var
  i,pow_x,pow_y,x0,y0:integer;
begin
  pow_x:=strtoint(tlabel(ActiveMDIChild.components[numerkomponentu2('pow_x')]).caption);
  pow_y:=strtoint(tlabel(ActiveMDIChild.components[numerkomponentu2('pow_y')]).caption);
  x0:=strtoint(tlabel(ActiveMDIChild.components[numerkomponentu2('x0')]).caption);
  y0:=strtoint(tlabel(ActiveMDIChild.components[numerkomponentu2('y0')]).caption);
  TImage(ActiveMDIChild.components[numerkomponentu2('Image')]).Picture.Graphic:=nil;
  with TImage(ActiveMDIChild.components[numerkomponentu2('Image')]) do
  begin
    if MultiPageDlg.OsieCheckBox.Checked then
    begin
      {o pozioma}
      Canvas.PolyLine([Point(0,y0),Point(width,y0)]);
      {strzaka pozioma}
      Canvas.PolyLine([Point(width - 10,y0 - 5),Point(width,y0)]);
      Canvas.PolyLine([Point(width - 10,y0 + 5),Point(width,y0)]);
      {o pionowa}
      Canvas.PolyLine([Point(x0-1,0),Point(x0-1,height)]);
      {strzaka pionowa}
      Canvas.PolyLine([Point(x0-6,9),Point(x0-1,0)]);
      Canvas.PolyLine([Point(x0+6,9),Point(x0-1,0)]);
    end;
    if MultiPageDlg.JednostkiCheckBox.Checked then
    begin
      {jednostki poziome}
      i:=0;
      repeat
        dec(i);
      until x0-1-i*pow_x>width;
      osie:=i;
      repeat
        Canvas.PolyLine([Point(x0-1-i*pow_x,y0-4),Point(x0-1-i*pow_x,y0+4)]);
        inc(i);
      until x0-1-i*pow_x<0;
      {jednostki pionowe}
      i:=0;
      repeat
        dec(i);
      until y0-i*pow_y>height;
      repeat
        Canvas.PolyLine([Point(x0-4,y0-i*pow_y),Point(x0+4,y0-i*pow_y)]);
        inc(i);
      until y0-i*pow_y<0;
    end;
  end;
end;

function TMainForm.real2int(x:extended):integer;
var s:string;
begin
  str(int(x):0:0,s);
  real2int:=strtoint(s);
end;

function TMainForm.str2real(s:string):extended;
var r:extended;
    a:integer;
begin
  val(s,r,a);
  str2real:=r;
end;

procedure TMainForm.RysujWykres;
var Result:Integer;
    poz,pop,wart:extended;
    poz2,pop2,wart2:extended;
    popx3,wartx3,poz3,pop3,wart3:extended;
    pow_x,pow_y,x0,y0:integer;
begin
  poz:=osie;
  pow_x:=strtoint(tlabel(ActiveMDIChild.components[numerkomponentu2('pow_x')]).caption);
  pow_y:=strtoint(tlabel(ActiveMDIChild.components[numerkomponentu2('pow_y')]).caption);
  x0:=strtoint(tlabel(ActiveMDIChild.components[numerkomponentu2('x0')]).caption);
  y0:=strtoint(tlabel(ActiveMDIChild.components[numerkomponentu2('y0')]).caption);
  with TImage(ActiveMDIChild.components[numerkomponentu2('Image')]) do
  begin
    {tutaj wstawiaj warto x, od ktrej ma by rysowany ten wykres}
    if MultiPageDlg.OkresCheckBox.Checked then poz:=-pi;
    pop:=0;
    if MultiPageDlg.XTabSet.TabIndex=0 then
    begin
      wart:=Str2Real(MultiPageDlg.A1Edit.Text)*sin(Str2Real(MultiPageDlg.W1Edit.Text)*poz+Str2Real(MultiPageDlg.Fi1Edit.Text)+
           +pi*Str2Real(MultiPageDlg.PI1Edit.Text));
    end;
    pop2:=0;
    if MultiPageDlg.YTabSet.TabIndex=0 then
    begin
      wart2:=Str2Real(MultiPageDlg.A2Edit.Text)*sin(Str2Real(MultiPageDlg.W2Edit.Text)*poz+Str2Real(MultiPageDlg.Fi2Edit.Text)+
            +pi*Str2Real(MultiPageDlg.PI2Edit.Text));
    end;
    pop3:=0;
    if MultiPageDlg.XY1RadioGroup.ItemIndex<>MultiPageDlg.XY2RadioGroup.ItemIndex then
    begin
      wart3:=wart2;
      popx3:=wart;
      wartx3:=wart;
    end else wart3:=wart+wart2;
    repeat
      poz:=poz+krok;
      pop:=wart;
      if MultiPageDlg.XTabSet.TabIndex=0 then
      begin
        wart:=Str2Real(MultiPageDlg.A1Edit.Text)*sin(Str2Real(MultiPageDlg.W1Edit.Text)*poz+
             +Str2Real(MultiPageDlg.Fi1Edit.Text)+
             +pi*Str2Real(MultiPageDlg.PI1Edit.Text));
      end;
      Canvas.Pen.Color:=MultiPageDlg.Kolor3Panel.Font.Color;
      if MultiPageDlg.XCheckBox.Checked then
      begin
        if MultiPageDlg.XY1RadioGroup.ItemIndex=1 then
        begin
          if y0-1-pop*pow_y<Height then  {ochrona przed przepeniem zakresu liczb}
             if y0-1-pop*pow_y>0 then {              -"-                      }
                Canvas.Polyline([Point(real2int(x0-1+(poz-krok)*pow_x),real2int(y0-1-pop*pow_y)),
                                       Point(real2int(x0-1+poz*pow_x),real2int(y0-1-wart*pow_y))]);
        end else
        begin
          if y0-1-(poz-krok)*pow_y<height then  {ochrona przed przepeniem zakresu liczb}
             if y0-1-(poz-krok)*pow_y>0 then {              -"-                      }
                Canvas.Polyline([Point(real2int(x0-1+pop*pow_x),real2int(y0-1-(poz-krok)*pow_y)),
                                       Point(real2int(x0-1+wart*pow_x),real2int(y0-1-poz*pow_y))]);
        end;
      end;
      pop2:=wart2;
      if MultiPageDlg.YTabSet.TabIndex=0 then
      begin
        wart2:=Str2Real(MultiPageDlg.A2Edit.Text)*sin(Str2Real(MultiPageDlg.W2Edit.Text)*poz+
               +StrToInt(MultiPageDlg.Fi2Edit.Text)+
               +pi*Str2Real(MultiPageDlg.PI2Edit.Text));
      end;
      Canvas.Pen.Color:=MultiPageDlg.Kolor4Panel.Font.Color;
      if MultiPageDlg.YCheckBox.Checked then
      begin
        if MultiPageDlg.XY2RadioGroup.ItemIndex=1 then
        begin
          if y0-1-pop2*pow_y<height then  {ochrona przed przepeniem zakresu liczb}
             if y0-1-pop2*pow_y>0 then {              -"-                      }
                 Canvas.Polyline([Point(real2int(x0-1+(poz-krok)*pow_x),real2int(y0-1-pop2*pow_y)),
                                       Point(real2int(x0-1+poz*pow_x),real2int(y0-1-wart2*pow_y))]);
        end else
        begin
          if y0-1-(poz-krok)*pow_y<height then  {ochrona przed przepeniem zakresu liczb}
             if y0-1-(poz-krok)*pow_y>0 then {              -"-                      }
                   Canvas.Polyline([Point(real2int(x0-1+pop2*pow_x),real2int(y0-1-(poz-krok)*pow_y)),
                                       Point(real2int(x0-1+wart2*pow_x),real2int(y0-1-poz*pow_y))]);
        end;
      end;
      Canvas.Pen.Color:=MultiPageDlg.Kolor5Panel.Font.Color;
      if MultiPageDlg.XYCheckBox.Checked then
      begin
        pop3:=wart3;
        if MultiPageDlg.XY1RadioGroup.ItemIndex<>MultiPageDlg.XY2RadioGroup.ItemIndex then
        begin
          wart3:=wart2;
          popx3:=wartx3;
          wartx3:=wart;
          Canvas.Polyline([Point(real2int(x0-1+popx3*pow_x),real2int(y0-1-pop3*pow_y)),
                                 Point(real2int(x0-1+wartx3*pow_x),real2int(y0-1-wart3*pow_y))]);
        end else
        begin
          wart3:=wart+wart2;
          if y0-1-pop3*pow_y<height then  {ochrona przed przepeniem zakresu liczb}
             if y0-1-pop3*pow_y>0 then {              -"-                      }
                Canvas.Polyline([Point(real2int(x0-1+(poz-krok)*pow_x),real2int(y0-1-pop3*pow_y)),
                                       Point(real2int(x0-1+poz*pow_x),real2int(y0-1-wart3*pow_y))]);
        end;
      end;
      if MultiPageDlg.OkresCheckBox.Checked then
      begin
        if poz>pi then break;
      end else
      begin
        if x0-1+poz*pow_x>Width then break;
      end;
    until false;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Screen.OnActiveFormChange := UpdateMenuItems;
end;

procedure TMainForm.CreateMDIChild(const Name: string);
var
  Child: TMDIChild;
begin
  { create a new MDI child window }
  Child := TMDIChild.Create(Application);
  Child.Caption := Name;
  TPanel(ActiveMDIChild.components[numerkomponentu2('Panel')]).OnEnter(nil);
  RysujWykres;
end;

procedure TMainForm.FileNewItemClick(Sender: TObject);
begin
  CreateMDIChild('Wykres numer ' + IntToStr(MDIChildCount + 1));
  TLabel(ActiveMDIChild.components[numerkomponentu2('NumerLabel')]).Caption:=IntToStr(MDIChildCount);
  if GalleryItem.Checked then Gallery.Show;
end;

procedure TMainForm.FileCloseItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then ActiveMDIChild.Close;
  if ActiveMDIChild = nil then Gallery.Visible:=False;
end;

procedure TMainForm.FileSaveAsItemClick(Sender: TObject);
begin
  { save current file under new name }
  If SaveDialog.Execute then TImage(ActiveMDIChild.components[numerkomponentu2('Image')]).Picture.SaveToFile(
     SaveDialog.FileName);
end;

procedure TMainForm.FileExitItemClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.CopyItemClick(Sender: TObject);
begin
  {copy selection to clipboard}
  Clipboard.Assign(TImage(ActiveMDIChild.components[numerkomponentu2('Image')]).Picture);
end;

procedure TMainForm.WindowCascadeItemClick(Sender: TObject);
begin
  Cascade;
end;

procedure TMainForm.WindowTileItemClick(Sender: TObject);
begin
  Tile;
end;

procedure TMainForm.WindowArrangeItemClick(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TMainForm.WindowMinimizeItemClick(Sender: TObject);
var
  I: Integer;
begin
  { Must be done backwards through the MDIChildren array }
  for I := MDIChildCount - 1 downto 0 do
    MDIChildren[I].WindowState := wsMinimized;
end;

procedure TMainForm.UpdateMenuItems(Sender: TObject);
begin
  FileCloseItem.Enabled := MDIChildCount > 0;
  FileCloseAllItem.Enabled := MDIChildCount > 0;
  FileSaveAsItem.Enabled := MDIChildCount > 0;
  CopyItem.Enabled := MDIChildCount > 0;
  GalleryItem.Enabled := MDIChildCount > 0;
  OptionsItem.Enabled := MDIChildCount > 0;
  WindowCascadeItem.Enabled := MDIChildCount > 0;
  WindowTileItem.Enabled := MDIChildCount > 0;
  WindowArrangeItem.Enabled := MDIChildCount > 0;
  WindowMinimizeItem.Enabled := MDIChildCount > 0;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Screen.OnActiveFormChange := nil;
end;

procedure TMainForm.OptionsItemClick(Sender: TObject);
begin
  TPanel(ActiveMDIChild.components[numerkomponentu2('Panel')]).OnEnter(nil);
  MultiPageDlg.NumerLabel.Caption:=TLabel(ActiveMDIChild.components[numerkomponentu2('NumerLabel')]).Caption;
  MultiPageDlg.Show;
end;

procedure TMainForm.HelpAboutItemClick(Sender: TObject);
begin
  Application.CreateForm(TAboutBox,AboutBox);
  AboutBox.ShowModal;
  AboutBox.Destroy;
end;

procedure TMainForm.FileCloseAllItemClick(Sender: TObject);
var
  I: Integer;
begin
  { Must be done backwards through the MDIChildren array }
  for I := MDIChildCount - 1 downto 0 do MDIChildren[I].Close;
  Gallery.Visible := False;
end;

procedure TMainForm.HelpItemClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS,0);
end;

procedure TMainForm.HelpOnHelpItemClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_HELPONHELP,0);
end;

procedure TMainForm.GalleryItemClick(Sender: TObject);
begin
  GalleryItem.Checked:=not GalleryItem.Checked;
  if GalleryItem.Checked then
  begin
    Gallery.Show;
  end else
  begin
    Gallery.Visible:=False;
  end;
end;

end.
